Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/CommonDef.h
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/CommonDef.h	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/CommonDef.h	(revision 195)
@@ -185,5 +185,5 @@
 // VPS constants
 // ====================================================================================================================
-#if MVHEVC
+#if QC_MVHEVC_B0046
 #define MAX_LAYER_NUM                     MAX_VIEW_NUM
 #endif
@@ -483,5 +483,5 @@
   NAL_UNIT_CODED_SLICE,
 #if H0566_TLA
-#if QC_REM_IDV
+#if QC_REM_IDV_B0046
   NAL_UNIT_RESERVED,
 #else
@@ -515,5 +515,5 @@
   NAL_UNIT_RESERVED_23,
   NAL_UNIT_UNSPECIFIED_24,
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   NAL_UNIT_VPS,
 #else
Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/NAL.h
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/NAL.h	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/NAL.h	(revision 195)
@@ -51,5 +51,5 @@
   NalRefIdc   m_nalRefIDC;   ///< nal_ref_idc
 #endif
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   unsigned    m_layerId;
   unsigned    m_temporalId;  ///< temporal_id
@@ -69,5 +69,5 @@
     NalUnitType nalUnitType,
     Bool        nalRefFlag,
-#if !VIDYO_VPS_INTEGRATION & !MVHEVC    
+#if !VIDYO_VPS_INTEGRATION & !QC_MVHEVC_B0046    
     Int         viewId,
     Bool        isDepth,
@@ -78,5 +78,5 @@
     :m_nalUnitType (nalUnitType)
     ,m_nalRefFlag  (nalRefFlag)
-#if !VIDYO_VPS_INTEGRATION & !MVHEVC
+#if !VIDYO_VPS_INTEGRATION & !QC_MVHEVC_B0046
     ,m_viewId      (viewId)
     ,m_isDepth     (isDepth)
@@ -139,5 +139,5 @@
     return m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR
 #if H0566_TLA
-#if !QC_REM_IDV    
+#if !QC_REM_IDV_B0046    
         || m_nalUnitType == NAL_UNIT_CODED_SLICE_IDV
 #endif
Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComDataCU.cpp	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComDataCU.cpp	(revision 195)
@@ -4307,5 +4307,5 @@
   {
     // col [2]
-#if !TMVP_INDEX_MODIFY
+#if !QC_TMVP_IDX_MOD_B0046
     Int iRefIdxSkip[2] = {-1, -1};
     for (Int i=0; i<2; i++)
@@ -4339,5 +4339,5 @@
 
     TComMv cColMv;
-#if TMVP_INDEX_MODIFY
+#if QC_TMVP_IDX_MOD_B0046
     Int iRefIdx = 0;
 #else
@@ -4376,5 +4376,5 @@
       }
     }
-#if !TMVP_INDEX_MODIFY
+#if !QC_TMVP_IDX_MOD_B0046
     iRefIdx = iRefIdxSkip[0];
 #else
@@ -4398,5 +4398,5 @@
       if ( getSlice()->isInterB() )
       {       
-#if !TMVP_INDEX_MODIFY
+#if !QC_TMVP_IDX_MOD_B0046
         iRefIdx = iRefIdxSkip[1];
 #else
@@ -6412,5 +6412,5 @@
   if( pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) >= 0 )
   {
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
     Bool bIsCurrRefLongTerm = m_pcSlice->getRefPic( eRefPicList, iRefIdx)->getIsLongTerm();
     Bool bIsNeibRefLongTerm = m_pcSlice->getRefPic( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx))->getIsLongTerm();
@@ -6561,5 +6561,5 @@
   Int iNeibRefPOC;
 
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
   Bool bIsCurrRefLongTerm = m_pcSlice->getRefPic( eRefPicList, iRefIdx)->getIsLongTerm();
   Bool bIsNeibRefLongTerm = false;
@@ -6568,5 +6568,5 @@
   {
     iNeibRefPOC = pcTmpCU->getSlice()->getRefPOC( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) );
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
     bIsNeibRefLongTerm = m_pcSlice->getRefPic( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx))->getIsLongTerm() ;
     if ( (bIsCurrRefLongTerm == bIsNeibRefLongTerm) && (iNeibRefPOC == iCurrRefPOC) )
@@ -6593,5 +6593,5 @@
     TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
     TComMv rcMv;
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
     bIsNeibRefLongTerm = m_pcSlice->getRefPic( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx))->getIsLongTerm(); 
     if ( bIsCurrRefLongTerm == bIsNeibRefLongTerm )
@@ -6617,5 +6617,5 @@
     pInfo->m_acMvCand[ pInfo->iN++] = rcMv;
     return true;
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
     }
 #endif
@@ -6627,5 +6627,5 @@
     TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList2nd)->getMv(uiIdx);
     TComMv rcMv;
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
     bIsNeibRefLongTerm = m_pcSlice->getRefPic( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx))->getIsLongTerm(); ;
     if ( bIsCurrRefLongTerm == bIsNeibRefLongTerm )
@@ -6651,5 +6651,5 @@
     pInfo->m_acMvCand[ pInfo->iN++] = rcMv;
     return true;
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
   }
 #endif
@@ -6764,5 +6764,5 @@
   Int iColPOC, iColRefPOC, iCurrPOC, iCurrRefPOC, iScale;
 #if SONY_COLPIC_AVAILABILITY
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
   Int iColViewOrderIdx, iCurrViewOrderIdx, iCurrRefViewOrderIdx;
 #else
@@ -6799,5 +6799,5 @@
   }
 
-#if !SONY_COLPIC_AVAILABILITY&!IV_AS_LT
+#if !SONY_COLPIC_AVAILABILITY&!QC_IV_AS_LT_B0046
   if( m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getViewId() != m_pcSlice->getViewId() )
     return false;
@@ -6827,5 +6827,5 @@
   iColRefPOC = pColCU->getSlice()->getRefPOC(eColRefPicList, iColRefIdx);
 
-#if !IV_AS_LT
+#if !QC_IV_AS_LT_B0046
 #if SONY_COLPIC_AVAILABILITY
   iColRefViewOrderIdx = pColCU->getSlice()->getRefPic( eColRefPicList, pColCU->getCUMvField(eColRefPicList)->getRefIdx(uiAbsPartAddr))->getViewOrderIdx();
@@ -6848,5 +6848,5 @@
 
   iCurrRefPOC = m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getPOC();
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
   {
     assert( ((iColPOC != iColRefPOC)&&(iCurrPOC != iCurrRefPOC))||((iColPOC == iColRefPOC)&&(iCurrPOC == iCurrRefPOC)));
Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComDepthMapGenerator.h
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComDepthMapGenerator.h	(revision 195)
@@ -239,5 +239,5 @@
   Bool              m_bDecoder;
   TComPrediction*   m_pcPrediction;
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   TComVPSAccess*    m_pcVPSAccess;
 #endif
Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComPic.cpp
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComPic.cpp	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComPic.cpp	(revision 195)
@@ -519,5 +519,5 @@
       UInt uiTempLayer = currSlice->getRefPic(eRefPicList, lpRef)->getCurrSlice()->getTLayer(); 
       Int iTempDiff = (iTempPoc > iPOCCurr) ? (iTempPoc - iPOCCurr): (iPOCCurr - iTempPoc);
-#if QC_REM_IDV
+#if QC_REM_IDV_B0046
       TComSlice* refSlice = currSlice->getRefPic(eRefPicList, lpRef)->getCurrSlice();
       bRAP = (refSlice->getSPS()->getViewId() && (refSlice->getNalUnitType() == NAL_UNIT_CODED_SLICE_IDR || refSlice->getNalUnitType() == NAL_UNIT_CODED_SLICE_CRA))? 1: 0;      
Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComPic.h
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComPic.h	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComPic.h	(revision 195)
@@ -140,5 +140,5 @@
   TComSlice*    getSlice(Int i)       { return  m_apcPicSym->getSlice(i);  }
   TComSlice*    getCurrSlice()        { return  m_apcPicSym->getSlice(m_uiCurrSliceIdx);  }
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   TComVPS*      getVPS()              { return  m_apcPicSym->getSlice(m_uiCurrSliceIdx)->getVPS();  }
 #endif
Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComPrediction.cpp	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComPrediction.cpp	(revision 195)
@@ -924,5 +924,5 @@
 }
 #endif
-#if !MVHEVC
+#if !QC_MVHEVC_B0046
   Int     ixFrac      = iHor & 0x3;
   Int     iyFrac      = iVer & 0x3;
Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComSlice.cpp	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComSlice.cpp	(revision 195)
@@ -44,5 +44,5 @@
 
 TComSlice::TComSlice()
-#if MVHEVC
+#if QC_MVHEVC_B0046
 : m_iPPSId                        ( 0  )
 #else
@@ -146,5 +146,5 @@
   resetWpScalingLC(m_weightPredTableLC);
   initWpAcDcParam();
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
   for(Int iNumCount = 0; iNumCount < MAX_NUM_REF+1; iNumCount++)
   {
@@ -483,5 +483,5 @@
   {
     pcRefPic = xGetInterViewRefPic( rapcInterViewRefPics, getViewId() + m_pcSPS->getUsableInterViewRef(i) );
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
     pcRefPic->setIsLongTerm( 1 );
 #else
@@ -528,5 +528,5 @@
   {
     m_apcRefPicList[0][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL0() ? refPicListTemp0[ m_RefPicListModification.getRefPicSetIdxL0(cIdx) ] : refPicListTemp0[cIdx];
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
     setWasLongTerm(m_apcRefPicList[0][cIdx]->getIsLongTerm(), REF_PIC_LIST_0, cIdx);
 #endif
@@ -542,5 +542,5 @@
     {
       m_apcRefPicList[1][cIdx] = m_RefPicListModification.getRefPicListModificationFlagL1() ? refPicListTemp1[ m_RefPicListModification.getRefPicSetIdxL1(cIdx) ] : refPicListTemp1[cIdx];
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
       setWasLongTerm(m_apcRefPicList[1][cIdx]->getIsLongTerm(), REF_PIC_LIST_1, cIdx);
 #endif
@@ -897,5 +897,5 @@
     for(i=0;i<pReferencePictureSet->getNumberOfPositivePictures()+pReferencePictureSet->getNumberOfNegativePictures();i++)
     {
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
        if( rpcPic->getPicSym()->getSlice(0)->getPOC() == this->getPOC() + pReferencePictureSet->getDeltaPOC(i))
 #else
@@ -911,5 +911,5 @@
     for(;i<pReferencePictureSet->getNumberOfPictures();i++)
     {
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
      if( (rpcPic->getPicSym()->getSlice(0)->getPOC()%(1<<rpcPic->getPicSym()->getSlice(0)->getSPS()->getBitsForPOC())) == pReferencePictureSet->getPOC(i)%(1<<rpcPic->getPicSym()->getSlice(0)->getSPS()->getBitsForPOC()))
 #else
@@ -1419,5 +1419,5 @@
 // Video parameter set (VPS)
 // ------------------------------------------------------------------------------------------------
-#if MVHEVC
+#if QC_MVHEVC_B0046
 TComVPS::TComVPS()
 : m_VPSId                     (  0)
@@ -1496,5 +1496,5 @@
 
 TComSPS::TComSPS()
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
 : m_VPSId                     (  0)
 , m_SPSId                     (  0)
@@ -1548,5 +1548,5 @@
 , m_bLCMod                    (false)
 #if H0412_REF_PIC_LIST_RESTRICTION
-#if MVHEVC
+#if QC_MVHEVC_B0046
 , m_restrictedRefPicListsFlag   (  0)
 #else
@@ -1805,5 +1805,5 @@
 TComSPS::initMultiviewSPS( UInt uiViewId, Int iViewOrderIdx, UInt uiCamParPrecision, Bool bCamParSlice, Int** aaiScale, Int** aaiOffset )
 {
-#if !MVHEVC
+#if !QC_MVHEVC_B0046
   AOT( uiViewId == 0 && iViewOrderIdx != 0 );
   AOT( uiViewId != 0 && iViewOrderIdx == 0 );
@@ -1817,5 +1817,5 @@
   ::memset( m_aaiCodedScale,  0x00, sizeof( m_aaiCodedScale  ) );
   ::memset( m_aaiCodedOffset, 0x00, sizeof( m_aaiCodedOffset ) );
-#if !MVHEVC
+#if !QC_MVHEVC_B0046
   if( !m_bCamParInSliceHeader )
   {
@@ -2448,5 +2448,5 @@
 , m_ppsMap(MAX_NUM_PPS)
 , m_apsMap(MAX_NUM_APS)
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
 , m_vpsMap(MAX_NUM_VPS)
 #endif
Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComSlice.h	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TComSlice.h	(revision 195)
@@ -144,5 +144,5 @@
 #endif
 
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
 /// VPS class
 
@@ -156,5 +156,5 @@
 
   UInt        m_uiExtensionType;
-#if !MVHEVC  
+#if !QC_MVHEVC_B0046  
   Bool        m_bDependentFlag[MAX_LAYER_NUM];
 #else
@@ -168,9 +168,9 @@
 #endif
   UInt        m_uiViewId[MAX_LAYER_NUM];
-#if !MVHEVC  
+#if !QC_MVHEVC_B0046  
   Bool        m_bDepthFlag[MAX_LAYER_NUM];
 #endif
   Int         m_iViewOrderIdx[MAX_LAYER_NUM];
-#if !MVHEVC  
+#if !QC_MVHEVC_B0046  
   UInt        m_uiDependentLayer[MAX_LAYER_NUM];
 #endif
@@ -195,5 +195,5 @@
   Bool    getTemporalNestingFlag   ()         { return m_uiMaxLayers;   }
   Void    setTemporalNestingFlag   (UInt t)   { m_bTemporalIdNestingFlag = t; }
-#if !MVHEVC
+#if !QC_MVHEVC_B0046
   Void    setExtensionType(UInt v)                     { m_uiExtensionType = v;    }
   UInt    getExtensionType()                             { return m_uiExtensionType; }
@@ -204,5 +204,5 @@
   Void    setViewId(UInt v, UInt layer)                     { m_uiViewId[layer] = v;    }
   UInt    getViewId(UInt layer)                             { return m_uiViewId[layer]; }
-#if !MVHEVC 
+#if !QC_MVHEVC_B0046 
   Void    setDepthFlag(Bool d, UInt layer)                  { m_bDepthFlag[layer] = d;    }
   Bool    getDepthFlag(UInt layer)                          { return m_bDepthFlag[layer]; }
@@ -210,5 +210,5 @@
   Void    setViewOrderIdx(Int v, UInt layer)                { m_iViewOrderIdx[layer] = v;    }
   Int     getViewOrderIdx(UInt layer)                       { return m_iViewOrderIdx[layer]; }
-#if !MVHEVC   
+#if !QC_MVHEVC_B0046   
   Void    setDependentLayer(UInt v, UInt layer)                     { m_uiDependentLayer[layer] = v;    }
   UInt    getDependentLayer(UInt layer)                             { return m_uiDependentLayer[layer]; }
@@ -222,5 +222,5 @@
   Void    setMaxLatencyIncrease(UInt v, UInt tLayer)                { m_uiMaxLatencyIncrease[tLayer] = v;    }
   UInt    getMaxLatencyIncrease(UInt tLayer)                        { return m_uiMaxLatencyIncrease[tLayer]; }
-#if MVHEVC
+#if QC_MVHEVC_B0046
   Void    setNumHRDParameters(UInt n)                                { m_uiNumHRDParameter = n;    }
   UInt    getNumHRDParameters()                                      { return m_uiNumHRDParameter; }
@@ -249,5 +249,5 @@
 {
 private:
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   Int          m_VPSId;
 #endif
@@ -422,5 +422,5 @@
   TComSPS();
   virtual ~TComSPS();
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   Int  getVPSId       ()         { return m_VPSId;          }
   Void setVPSId       (Int i)    { m_VPSId = i;             }
@@ -1252,8 +1252,8 @@
   
   // access channel
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   TComVPS*    m_pcVPS;
 #endif
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
   Bool                  m_bWasLongTerm[2][MAX_NUM_REF+1]; //was long-term picture
 #endif
@@ -1331,5 +1331,5 @@
   Int        m_aaiCodedOffset[2][MAX_VIEW_NUM];
 
-#if SONY_COLPIC_AVAILABILITY|MVHEVC
+#if SONY_COLPIC_AVAILABILITY|QC_MVHEVC_B0046
   Int         m_iViewOrderIdx;
 #endif
@@ -1345,9 +1345,9 @@
   Void      initTiles();
 
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   Void      setVPS          ( TComVPS* pcVPS ) { m_pcVPS = pcVPS; }
   TComVPS*  getVPS          () { return m_pcVPS; }
 #endif
-#if IV_AS_LT
+#if QC_IV_AS_LT_B0046
   Void          setWasLongTerm( Bool lt,  RefPicList e, Int iRefIdx ) { m_bWasLongTerm[e][iRefIdx] = lt; }
   Bool          getWasLongTerm( RefPicList e, Int iRefIdx           ) { return m_bWasLongTerm[e][iRefIdx] ; }
@@ -1626,5 +1626,5 @@
   Void setViewId( Int viewId )       { m_viewId = viewId;   }
   Int  getViewId()                   { return m_viewId;     }
-#if MVHEVC
+#if QC_MVHEVC_B0046
   Void    setViewOrderIdx(Int v, UInt layer)                { m_iViewOrderIdx = v;    }
   Int     getViewOrderIdx()                                 { return m_iViewOrderIdx; }
@@ -1698,5 +1698,5 @@
   }
 
-#if MVHEVC
+#if QC_MVHEVC_B0046
   Void clearPSList()
   {
@@ -1714,5 +1714,5 @@
   ParameterSetManager();
   virtual ~ParameterSetManager();
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   //! store video parameter set and take ownership of it 
   Void storeVPS(TComVPS *vps) { m_vpsMap.storePS( vps->getVPSId(), vps); };
@@ -1720,5 +1720,5 @@
   TComVPS* getVPS(Int vpsId)  { return m_vpsMap.getPS(vpsId); };
   TComVPS* getFirstVPS()      { return m_vpsMap.getFirstPS(); };
-#if MVHEVC
+#if QC_MVHEVC_B0046
   Void     clearVPS()         { m_vpsMap.clearPSList(); };
   Void     clearSPS()         { m_spsMap.clearPSList(); };
@@ -1747,5 +1747,5 @@
   ParameterSetMap<TComPPS> m_ppsMap; 
   ParameterSetMap<TComAPS> m_apsMap; 
-#if VIDYO_VPS_INTEGRATION|MVHEVC
+#if VIDYO_VPS_INTEGRATION|QC_MVHEVC_B0046
   ParameterSetMap<TComVPS> m_vpsMap; 
 #endif
Index: branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TypeDef.h	(revision 194)
+++ branches/HTM-5.0-Qualcomm/source/Lib/TLibCommon/TypeDef.h	(revision 195)
@@ -41,10 +41,10 @@
 //! \ingroup TLibCommon
 //! \{
-#define MVHEVC                            0
-#define            IV_AS_LT               1   //inter-view reference pictures are treated as long-term pictures         
-#define            TMVP_INDEX_MODIFY      1   //the reference index for temporal merging candidate is set to 0, as defined in HEVC
-#define            QC_REM_IDV             1   //nal unit type NAL_UNIT_CODED_SLICE_IDV is removed.
-#define            BUG_FIX_HTM            1
-#if !MVHEVC
+#define QC_MVHEVC_B0046                   0
+#define QC_IV_AS_LT_B0046                 1   //JCT3V-B0046: Disable 3DHEVC tools 
+#define QC_TMVP_IDX_MOD_B0046             1   //JCT3V-B0046: inter-view reference pictures are treated as long-term pictures, scaling of motion vectors for DCP based on ViewId/ViewOrderIdx is disabled 
+#define QC_REM_IDV_B0046                  1   //JCT3V-B0046: the reference index for temporal merging candidate is set to 0, as defined in HEVC
+#define FIX_DEL_NULLPTR                   1
+#if !QC_MVHEVC_B0046
 ///// ***** FIXES *********
 // A
@@ -482,5 +482,5 @@
 // VPS INTEGRATION
 // ====================================================================================================================
-#if !MVHEVC
+#if !QC_MVHEVC_B0046
 #if VIDYO_VPS_INTEGRATION
 #define MAX_NUM_VPS 10