Index: branches/HTM-5.0-Nokia/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/App/TAppDecoder/TAppDecTop.cpp	(revision 200)
+++ branches/HTM-5.0-Nokia/source/App/TAppDecoder/TAppDecTop.cpp	(revision 201)
@@ -88,10 +88,10 @@
 #endif
   
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
   Int iDepthViewIdx = 0;
   Int iTextureViewIdx=0;
-  Bool first_frame=1;
-  Bool viewid_zero=true;
-  Int FCO_index=0;  //when the current frame is not first frame,use FCO_index stand for viewDepth. 
+  Bool firstFrame=1;
+  Bool viewIdZero=true;
+  Int fcoIndex=0;  //when the current frame is not first frame,use FCO_index stand for viewDepth. 
 #endif
 
@@ -110,6 +110,6 @@
     pcListPic[i] = NULL;
     newPicture[i] = false;
-#if FLEX_CODING_ORDER
-    FCO_Order[i]=NULL;
+#if FLEX_CODING_ORDER_M23723
+    m_fcoOrder[i]=NULL;
 #endif
 
@@ -173,17 +173,17 @@
         depth = getVPSAccess()->getActiveVPS()->getDepthFlag(nalu.m_layerId);
       }
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
       if (viewId>0)
       {
-        viewid_zero=false;
-      }
-      if (viewid_zero==false&&viewId==0)
-      {
-        first_frame=0; //if viewId has been more than zero and now it set to zero again, we can see that it is not the first view
-      }
-      if (first_frame)
+        viewIdZero=false;
+      }
+      if (viewIdZero==false&&viewId==0)
+      {
+        firstFrame=0; //if viewId has been more than zero and now it set to zero again, we can see that it is not the first view
+      }
+      if (firstFrame)
       { // if the current view is first frame, we set the viewDepthId as texture plus depth and get the FCO order 
         viewDepthId = iDepthViewIdx+iTextureViewIdx;
-        FCO_viewDepthId=viewDepthId;
+        m_fcoViewDepthId=viewDepthId;
       }
       else
@@ -192,7 +192,7 @@
         if (depth)
         {
-          for (FCO_index=0;FCO_index<2*MAX_VIEW_NUM;FCO_index++ )
+          for (fcoIndex=0;fcoIndex<2*MAX_VIEW_NUM;fcoIndex++ )
           {
-            if (FCO_Order[FCO_index]=='D')
+            if (m_fcoOrder[fcoIndex]=='D')
             {
               if (viewId==viewDepthId)
@@ -205,7 +205,7 @@
         else
         {
-          for (FCO_index=0;FCO_index<2*MAX_VIEW_NUM;FCO_index++ )
+          for (fcoIndex=0;fcoIndex<2*MAX_VIEW_NUM;fcoIndex++ )
           {
-            if (FCO_Order[FCO_index]=='T')
+            if (m_fcoOrder[fcoIndex]=='T')
             {
               if (viewId==viewDepthId)
@@ -217,5 +217,5 @@
         }
 
-        viewDepthId=FCO_index;
+        viewDepthId=fcoIndex;
 
       }
@@ -229,17 +229,17 @@
       Int viewId = nalu.m_viewId;
       Int depth = nalu.m_isDepth ? 1 : 0;
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
       if (viewId>0)
       {
-        viewid_zero=false;
-      }
-      if (viewid_zero==false&&viewId==0)
-      {
-        first_frame=0;
-      }
-      if (first_frame)
+        viewIdZero=false;
+      }
+      if (viewIdZero==false&&viewId==0)
+      {
+        firstFrame=0;
+      }
+      if (firstFrame)
       {
         viewDepthId = iDepthViewIdx+iTextureViewIdx;
-        FCO_viewDepthId=viewDepthId;
+        m_fcoViewDepthId=viewDepthId;
       }
       else
@@ -248,7 +248,7 @@
         if (depth)
         {
-          for (FCO_index=0;FCO_index<2*MAX_VIEW_NUM;FCO_index++ )
+          for (fcoIndex=0;fcoIndex<2*MAX_VIEW_NUM;fcoIndex++ )
           {
-            if (FCO_Order[FCO_index]=='D')
+            if (m_fcoOrder[fcoIndex]=='D')
             {
               if (viewId==viewDepthId)
@@ -261,7 +261,7 @@
         else
         {
-          for (FCO_index=0;FCO_index<2*MAX_VIEW_NUM;FCO_index++ )
+          for (fcoIndex=0;fcoIndex<2*MAX_VIEW_NUM;fcoIndex++ )
           {
-            if (FCO_Order[FCO_index]=='T')
+            if (m_fcoOrder[fcoIndex]=='T')
             {
               if (viewId==viewDepthId)
@@ -273,5 +273,5 @@
         }
 
-        viewDepthId=FCO_index;
+        viewDepthId=fcoIndex;
 
       }
@@ -338,16 +338,16 @@
         {
           previousPictureDecoded = true;
-#if FLEX_CODING_ORDER
-          if (first_frame)
-          {
+#if FLEX_CODING_ORDER_M23723
+        if (firstFrame)
+        {
             if (depth)
             {
                 iDepthViewIdx++;
-                FCO_Order[viewDepthId]='D';
+                m_fcoOrder[viewDepthId]='D';
             }
             else
            {
                 iTextureViewIdx++;
-                FCO_Order[viewDepthId]='T';
+                m_fcoOrder[viewDepthId]='T';
            }
           }
@@ -657,9 +657,9 @@
 TDecTop* TAppDecTop::getTDecTop( Int viewId, Bool isDepth )
 { 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
   Int viewnumber=0;
   Int i=0;
-  Bool FCO_flag=0;
-  if (viewId>FCO_viewDepthId)
+  Bool fcoFlag=0;
+  if (viewId>m_fcoViewDepthId)
   {
     return NULL;
@@ -669,11 +669,11 @@
     if (isDepth)
    {
-      for ( i=0; i<=FCO_viewDepthId;i++)
-      {
-         if (FCO_Order[i]=='D')
+      for ( i=0; i<=m_fcoViewDepthId;i++)
+      {
+         if (m_fcoOrder[i]=='D')
          {
            if (viewnumber==viewId)
            {
-             FCO_flag=1;
+             fcoFlag=1;
              break;
            }
@@ -685,11 +685,11 @@
     else
     {
-      for ( i=0; i<=FCO_viewDepthId;i++)
-      {
-        if (FCO_Order[i]=='T')
+      for ( i=0; i<=m_fcoViewDepthId;i++)
+      {
+        if (m_fcoOrder[i]=='T')
         {
           if (viewnumber==viewId)
           {
-            FCO_flag=1;
+            fcoFlag=1;
             break;
           }
@@ -699,5 +699,5 @@
       }
     }
-    if (FCO_flag)
+    if (fcoFlag)
     {
       return m_tDecTop[i];
@@ -731,5 +731,5 @@
   assert( ( viewId >= 0 ) );
 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
 if (getTDecTop(viewId,isDepth))
 {
Index: branches/HTM-5.0-Nokia/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- branches/HTM-5.0-Nokia/source/App/TAppDecoder/TAppDecTop.h	(revision 200)
+++ branches/HTM-5.0-Nokia/source/App/TAppDecoder/TAppDecTop.h	(revision 201)
@@ -71,7 +71,7 @@
   Bool                            m_useDepth;
 
-#if FLEX_CODING_ORDER
-  Int  FCO_viewDepthId;
-  Char FCO_Order[MAX_VIEW_NUM*2];
+#if FLEX_CODING_ORDER_M23723
+  Int  m_fcoViewDepthId;
+  Char m_fcoOrder[MAX_VIEW_NUM*2];
 #endif
 
Index: branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 200)
+++ branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 201)
@@ -112,5 +112,5 @@
     free (m_pchBitstreamFile) ;
 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
   if (m_pchMVCJointCodingOrder != NULL)
   {
@@ -212,5 +212,5 @@
   string cfg_ScalingListFile;
 
- #if FLEX_CODING_ORDER
+ #if FLEX_CODING_ORDER_M23723
   string cfg_JointCodingOrdering;
 #endif
@@ -260,5 +260,5 @@
   ("NumberOfViews",         m_iNumberOfViews,    0, "Number of views")
 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
   ("FCO",               m_b3DVFlexOrder,   false, "flexible coding order flag" )
   ("FCOCodingOrder",   cfg_JointCodingOrdering,  string(""), "The coding order for joint texture-depth coding")
@@ -553,5 +553,5 @@
   m_pchdQPFile = cfg_dQPFile.empty() ? NULL : strdup(cfg_dQPFile.c_str());
   
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
   m_pchMVCJointCodingOrder= cfg_JointCodingOrdering.empty()?NULL:strdup(cfg_JointCodingOrdering.c_str());
   // If flexible order is enabled and if depth comes before the texture for a view, disable VSO
@@ -1826,4 +1826,14 @@
   printf("TMVP:%d ", (m_enableTMVP[1] ? 1 : 0) );
 #endif
+
+#if FLEX_CODING_ORDER_M23723
+  printf("FCO:%d ",   (m_b3DVFlexOrder ? 1: 0));
+
+  if(m_b3DVFlexOrder)
+  {
+    printf("CodingOrder: %s ", m_pchMVCJointCodingOrder);
+  }
+#endif
+
 #if HHI_VSO
   printf("VSO:%d ", m_bUseVSO             );
Index: branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.h	(revision 200)
+++ branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.h	(revision 201)
@@ -89,5 +89,5 @@
   Bool      m_bUsingDepthMaps;
   
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
   char*  m_pchMVCJointCodingOrder;      ///<  texture-depth coding order
   Bool    m_b3DVFlexOrder;    ///<  flexible coding order flag
Index: branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncTop.cpp	(revision 200)
+++ branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncTop.cpp	(revision 201)
@@ -401,5 +401,5 @@
     {
 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
       // Detect whether depth comes before than texture for this view
       Bool isDepthFirst = false;
@@ -708,5 +708,5 @@
 #endif
 
-#if FLEX_CODING_ORDER && HHI_DMM_PRED_TEX
+#if FLEX_CODING_ORDER_M23723 && HHI_DMM_PRED_TEX
     m_acTEncDepthTopList[iViewIdx]->setUseDMM34( (m_b3DVFlexOrder && isDepthFirst) ? false : m_bUseDMM );
 #endif
@@ -717,5 +717,5 @@
 
 #if HHI_MPI
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
     m_acTEncDepthTopList[iViewIdx]->setUseMVI( (m_b3DVFlexOrder && isDepthFirst) ? false : m_bUseMVI );
 #else
@@ -1041,5 +1041,5 @@
 #endif
 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
       if (m_b3DVFlexOrder)
       {
@@ -1122,5 +1122,5 @@
       }
  
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
       }
 #endif
Index: branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TComSlice.cpp	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TComSlice.cpp	(revision 201)
@@ -1595,5 +1595,5 @@
 #endif
 
-#if FLEX_CODING_ORDER && HHI_DMM_PRED_TEX
+#if FLEX_CODING_ORDER_M23723 && HHI_DMM_PRED_TEX
 , m_bUseDMM34                   (false)
 #endif
Index: branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TComSlice.h
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TComSlice.h	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TComSlice.h	(revision 201)
@@ -394,5 +394,5 @@
 #endif
 
-#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER
+#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER_M23723
   Bool  m_bUseDMM34;
 #endif
@@ -678,5 +678,5 @@
 #endif
 
-#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER
+#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER_M23723
   Bool getUseDMM34()         { return m_bUseDMM34; }
   Void setUseDMM34( Bool b ) { m_bUseDMM34 = b;    }
Index: branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TypeDef.h	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TypeDef.h	(revision 201)
@@ -42,8 +42,8 @@
 //! \{
 #define QC_MVHEVC_B0046                   0   //JCT3V-B0046: disable 3DHEVC tools
-#define QC_IV_AS_LT_B0046                 1   //JCT3V-B0046: inter-view reference pictures are treated as long-term pictures, scaling of motion vectors for DCP based on ViewId/ViewOrderIdx is disabled  
-#define QC_TMVP_IDX_MOD_B0046             1   //JCT3V-B0046: the reference index for temporal merging candidate is set to 0, as defined in HEVC
-#define QC_REM_IDV_B0046                  1   //JCT3V-B0046: removal of IDV NAL unit type
-#define FIX_DEL_NULLPTR                   1
+#define QC_IV_AS_LT_B0046                 0   //JCT3V-B0046: inter-view reference pictures are treated as long-term pictures, scaling of motion vectors for DCP based on ViewId/ViewOrderIdx is disabled  
+#define QC_TMVP_IDX_MOD_B0046             0   //JCT3V-B0046: the reference index for temporal merging candidate is set to 0, as defined in HEVC
+#define QC_REM_IDV_B0046                  0   //JCT3V-B0046: removal of IDV NAL unit type
+#define FIX_DEL_NULLPTR                   0
 
 #define DV_V_RESTRICTION_B0037            1   // JCT3V-B0037 disparity vector vertical range restriction
@@ -63,6 +63,6 @@
 
 // FCO 
-#define FLEX_CODING_ORDER               1
-#if FLEX_CODING_ORDER
+#define FLEX_CODING_ORDER_M23723          1
+#if FLEX_CODING_ORDER_M23723
   #define DISABLE_FCO_FOR_VSO             0 // Optional compile settings to disable VSO with FCO.
 #endif
Index: branches/HTM-5.0-Nokia/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibDecoder/TDecTop.cpp	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibDecoder/TDecTop.cpp	(revision 201)
@@ -1003,5 +1003,5 @@
     TComPic * const pcTexturePic = m_isDepth ? m_tAppDecTop->getPicFromView(  m_viewId, pcSlice->getPOC(), false ) : NULL;
 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
     if (pcTexturePic != NULL)
     {
Index: branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncCfg.h	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncCfg.h	(revision 201)
@@ -327,5 +327,5 @@
 #endif
 
-#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER
+#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER_M23723
   Bool m_bUseDMM34;
 #endif
@@ -848,5 +848,5 @@
 #endif
 
-#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER
+#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER_M23723
   Void setUseDMM34( Bool b) { m_bUseDMM34 = b;    }
   Bool getUseDMM34()        { return m_bUseDMM34; }
Index: branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncGOP.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncGOP.cpp	(revision 201)
@@ -364,5 +364,5 @@
 
 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
       TComPic * pcTexturePic; 
       if(m_pcEncTop->getIsDepth() == 1)
@@ -492,10 +492,15 @@
 
 #if SAIT_VSO_EST_A0033
+#ifdef FLEX_CODING_ORDER_M23723    
 {
-   Bool flag_rec;
-   flag_rec =  ((m_pcEncTop->getEncTop()->getPicYuvFromView( pcSlice->getViewId(), pcSlice->getPOC(), false, true) == NULL) ? false: true);
-    m_pcRdCost->setVideoRecPicYuv( m_pcEncTop->getEncTop()->getPicYuvFromView( pcSlice->getViewId(), pcSlice->getPOC(), false, flag_rec ) );
-    m_pcRdCost->setDepthPicYuv   ( m_pcEncTop->getEncTop()->getPicYuvFromView( pcSlice->getViewId(), pcSlice->getPOC(), true, false ) );
+  Bool flagRec;
+  flagRec =  ((m_pcEncTop->getEncTop()->getPicYuvFromView( pcSlice->getViewId(), pcSlice->getPOC(), false, true) == NULL) ? false: true);
+  m_pcRdCost->setVideoRecPicYuv( m_pcEncTop->getEncTop()->getPicYuvFromView( pcSlice->getViewId(), pcSlice->getPOC(), false, flagRec ) );
+  m_pcRdCost->setDepthPicYuv   ( m_pcEncTop->getEncTop()->getPicYuvFromView( pcSlice->getViewId(), pcSlice->getPOC(), true, false ) );
 }
+#else
+  m_pcRdCost->setVideoRecPicYuv( m_pcEncTop->getEncTop()->getPicYuvFromView( pcSlice->getViewId(), pcSlice->getPOC(), false, true ) );
+  m_pcRdCost->setDepthPicYuv   ( m_pcEncTop->getEncTop()->getPicYuvFromView( pcSlice->getViewId(), pcSlice->getPOC(), true, false ) );
+#endif
 #endif
 #if LGE_WVSO_A0119
Index: branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncSbac.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncSbac.cpp	(revision 201)
@@ -1077,5 +1077,5 @@
 #if HHI_DMM_PRED_TEX
 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
     if ( !pcCU->getSlice()->getSPS()->getUseDMM34() )
     {
Index: branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncSearch.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncSearch.cpp	(revision 201)
@@ -2245,5 +2245,5 @@
 #if HHI_DMM_PRED_TEX
       
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
       if ( pcCU->getSlice()->getSPS()->getUseDMM34() )
       {
@@ -2272,5 +2272,5 @@
         uiRdModeList[ numModesForFullRD++ ] = DMM_CONTOUR_PREDTEX_D_IDX;
       }
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
       }
 #endif
@@ -2319,7 +2319,7 @@
 
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER
+#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER_M23723
       if( m_pcEncCfg->getIsDepth() && !predIntraLumaDMMAvailable( uiOrgMode, uiWidth, uiHeight, pcCU->getSlice()->getSPS()->getUseDMM34() ) 
-#if LGE_EDGE_INTRA
+#if LGE_EDGE_INTRA_A0070
         && uiOrgMode < EDGE_INTRA_IDX
 #endif
@@ -2329,5 +2329,5 @@
 
       if( m_pcEncCfg->getIsDepth() && !predIntraLumaDMMAvailable( uiOrgMode, uiWidth, uiHeight ) 
-#if LGE_EDGE_INTRA
+#if LGE_EDGE_INTRA_A0070
         && uiOrgMode < EDGE_INTRA_IDX
 #endif
@@ -6484,5 +6484,5 @@
 
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-#if ((HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX)&&FLEX_CODING_ORDER)
+#if ((HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX)&&FLEX_CODING_ORDER_M23723)
 Bool TEncSearch::predIntraLumaDMMAvailable( UInt uiMode, UInt uiWidth, UInt uiHeight, Bool bDMMAvailable34 )
 #else
@@ -6517,5 +6517,5 @@
     }
 
-#if FLEX_CODING_ORDER
+#if FLEX_CODING_ORDER_M23723
     if ( !bDMMAvailable34 )
     {
Index: branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncSearch.h
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncSearch.h	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncSearch.h	(revision 201)
@@ -336,5 +336,5 @@
   Bool predIntraLumaDMMAvailable  ( UInt           uiMode, 
                                     UInt           uiWidth, 
-#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER
+#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER_M23723
                                     UInt         uiHeight, 
                                     Bool         bDMMAvailable34 );
Index: branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncTop.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncTop.cpp	(revision 200)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibEncoder/TEncTop.cpp	(revision 201)
@@ -770,5 +770,5 @@
 #endif
 
-#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER
+#if HHI_DMM_PRED_TEX && FLEX_CODING_ORDER_M23723
   m_cSPS.setUseDMM34( m_bUseDMM34 );
 #endif