Index: branches/HTM-5.0-Nokia/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/App/TAppDecoder/TAppDecTop.cpp	(revision 201)
+++ branches/HTM-5.0-Nokia/source/App/TAppDecoder/TAppDecTop.cpp	(revision 202)
@@ -272,12 +272,9 @@
           }
         }
-
         viewDepthId=fcoIndex;
-
       }
 #else
   viewDepthId = viewId * 2 + depth;   // coding order T0D0T1D1T2D2
 #endif
-     
 #endif
 #endif     
Index: branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 201)
+++ branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 202)
@@ -111,5 +111,4 @@
   if (m_pchBitstreamFile != NULL)
     free (m_pchBitstreamFile) ;
-
 #if FLEX_CODING_ORDER_M23723
   if (m_pchMVCJointCodingOrder != NULL)
@@ -118,5 +117,4 @@
   }
 #endif
-
 #if HHI_VSO
   if (  m_pchVSOConfig != NULL)
@@ -259,10 +257,8 @@
   
   ("NumberOfViews",         m_iNumberOfViews,    0, "Number of views")
-
 #if FLEX_CODING_ORDER_M23723
   ("FCO",               m_b3DVFlexOrder,   false, "flexible coding order flag" )
   ("FCOCodingOrder",   cfg_JointCodingOrdering,  string(""), "The coding order for joint texture-depth coding")
 #endif
-
   /* Unit definition parameters */
   ("MaxCUWidth",          m_uiMaxCUWidth,  64u)
@@ -552,5 +548,4 @@
   m_pchBitstreamFile = cfg_BitstreamFile.empty() ? NULL : strdup(cfg_BitstreamFile.c_str());
   m_pchdQPFile = cfg_dQPFile.empty() ? NULL : strdup(cfg_dQPFile.c_str());
-  
 #if FLEX_CODING_ORDER_M23723
   m_pchMVCJointCodingOrder= cfg_JointCodingOrdering.empty()?NULL:strdup(cfg_JointCodingOrdering.c_str());
@@ -592,9 +587,4 @@
 #endif
 #endif
-
-
-
-
-  
   m_pchColumnWidth = cfg_ColumnWidth.empty() ? NULL: strdup(cfg_ColumnWidth.c_str());
   m_pchRowHeight = cfg_RowHeight.empty() ? NULL : strdup(cfg_RowHeight.c_str());
@@ -1826,5 +1816,4 @@
   printf("TMVP:%d ", (m_enableTMVP[1] ? 1 : 0) );
 #endif
-
 #if FLEX_CODING_ORDER_M23723
   printf("FCO:%d ",   (m_b3DVFlexOrder ? 1: 0));
@@ -1835,5 +1824,4 @@
   }
 #endif
-
 #if HHI_VSO
   printf("VSO:%d ", m_bUseVSO             );
Index: branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.h	(revision 201)
+++ branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncCfg.h	(revision 202)
@@ -90,5 +90,5 @@
   
 #if FLEX_CODING_ORDER_M23723
-  char*  m_pchMVCJointCodingOrder;      ///<  texture-depth coding order
+  Char*  m_pchMVCJointCodingOrder;      ///<  texture-depth coding order
   Bool    m_b3DVFlexOrder;    ///<  flexible coding order flag
 #endif
Index: branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncTop.cpp	(revision 201)
+++ branches/HTM-5.0-Nokia/source/App/TAppEncoder/TAppEncTop.cpp	(revision 202)
@@ -707,5 +707,4 @@
     m_acTEncDepthTopList[iViewIdx]->setUseDMM                     ( m_bUseDMM );
 #endif
-
 #if FLEX_CODING_ORDER_M23723 && HHI_DMM_PRED_TEX
     m_acTEncDepthTopList[iViewIdx]->setUseDMM34( (m_b3DVFlexOrder && isDepthFirst) ? false : m_bUseDMM );
@@ -715,5 +714,4 @@
     m_acTEncDepthTopList[iViewIdx]->setUseQTLPC                   (m_bUseQTLPC);
 #endif
-
 #if HHI_MPI
 #if FLEX_CODING_ORDER_M23723
@@ -723,6 +721,4 @@
 #endif
 #endif
-
-
 #if RWTH_SDC_DLT_B0036
       m_acTEncDepthTopList[iViewIdx]->setUseDLT                   ( m_bUseDLT );
@@ -1090,12 +1086,4 @@
 
 #endif
-
-//original code
-
-
-
-
-
-
       for(Int iViewIdx=0; iViewIdx < m_iNumberOfViews; iViewIdx++ )
       {
Index: branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TComSlice.cpp
===================================================================
--- branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TComSlice.cpp	(revision 201)
+++ branches/HTM-5.0-Nokia/source/Lib/TLibCommon/TComSlice.cpp	(revision 202)
@@ -1594,9 +1594,7 @@
 , m_bUseDMM                   (false)
 #endif
-
 #if FLEX_CODING_ORDER_M23723 && HHI_DMM_PRED_TEX
 , m_bUseDMM34                   (false)
 #endif
-
 #if OL_QTLIMIT_PREDCODING_B0068
 , m_bUseQTLPC                 (false)