Index: branches/SHM-2.1-dev/cfg/encoder_lowdelay_P_he10.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/encoder_lowdelay_P_he10.cfg	(revision 193)
+++ branches/SHM-2.1-dev/cfg/encoder_lowdelay_P_he10.cfg	(revision 211)
@@ -102,7 +102,19 @@
 
 #============ Rate Control ======================
-RateCtrl                            : 0                # 0: Disable rate control 1: Enable rate control
-TargetBitrate                       : 1000             # input target bitrate when RateCtrl is enable
-NumLCUInUnit                        : 1                # Number of LCU in an Unit. Fraction is not allowed
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
 
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
Index: branches/SHM-2.1-dev/cfg/encoder_lowdelay_P_main.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/encoder_lowdelay_P_main.cfg	(revision 193)
+++ branches/SHM-2.1-dev/cfg/encoder_lowdelay_P_main.cfg	(revision 211)
@@ -102,11 +102,19 @@
 
 #============ Rate Control ======================
-RateControl                         : 0                # Rate control: enable rate control
-TargetBitrate                       : 1000000          # Rate control: target bitrate, in bps
-KeepHierarchicalBit                 : 1                # Rate control: keep hierarchical bit allocation in rate control algorithm
-LCULevelRateControl                 : 1                # Rate control: 1: LCU level RC; 0: picture level RC
-RCLCUSeparateModel                  : 1                # Rate control: use LCU level separate R-lambda model
-InitialQP                           : 0                # Rate control: initial QP
-RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
 
 SEIpictureDigest                    : 1
Index: branches/SHM-2.1-dev/cfg/encoder_lowdelay_P_main10.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/encoder_lowdelay_P_main10.cfg	(revision 193)
+++ branches/SHM-2.1-dev/cfg/encoder_lowdelay_P_main10.cfg	(revision 211)
@@ -102,11 +102,19 @@
 
 #============ Rate Control ======================
-RateControl                         : 0                # Rate control: enable rate control
-TargetBitrate                       : 1000000          # Rate control: target bitrate, in bps
-KeepHierarchicalBit                 : 1                # Rate control: keep hierarchical bit allocation in rate control algorithm
-LCULevelRateControl                 : 1                # Rate control: 1: LCU level RC; 0: picture level RC
-RCLCUSeparateModel                  : 1                # Rate control: use LCU level separate R-lambda model
-InitialQP                           : 0                # Rate control: initial QP
-RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
 
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
Index: branches/SHM-2.1-dev/cfg/encoder_lowdelay_he10.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/encoder_lowdelay_he10.cfg	(revision 193)
+++ branches/SHM-2.1-dev/cfg/encoder_lowdelay_he10.cfg	(revision 211)
@@ -102,7 +102,19 @@
 
 #============ Rate Control ======================
-RateCtrl                            : 0                # 0: Disable rate control 1: Enable rate control
-TargetBitrate                       : 1000             # input target bitrate when RateCtrl is enable
-NumLCUInUnit                        : 1                # Number of LCU in an Unit. Fraction is not allowed
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
 
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
Index: branches/SHM-2.1-dev/cfg/encoder_lowdelay_main.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/encoder_lowdelay_main.cfg	(revision 193)
+++ branches/SHM-2.1-dev/cfg/encoder_lowdelay_main.cfg	(revision 211)
@@ -102,11 +102,19 @@
 
 #============ Rate Control ======================
-RateControl                         : 0                # Rate control: enable rate control
-TargetBitrate                       : 1000000          # Rate control: target bitrate, in bps
-KeepHierarchicalBit                 : 1                # Rate control: keep hierarchical bit allocation in rate control algorithm
-LCULevelRateControl                 : 1                # Rate control: 1: LCU level RC; 0: picture level RC
-RCLCUSeparateModel                  : 1                # Rate control: use LCU level separate R-lambda model
-InitialQP                           : 0                # Rate control: initial QP
-RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
 
 SEIpictureDigest                    : 1
Index: branches/SHM-2.1-dev/cfg/encoder_lowdelay_main10.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/encoder_lowdelay_main10.cfg	(revision 193)
+++ branches/SHM-2.1-dev/cfg/encoder_lowdelay_main10.cfg	(revision 211)
@@ -102,11 +102,19 @@
 
 #============ Rate Control ======================
-RateControl                         : 0                # Rate control: enable rate control
-TargetBitrate                       : 1000000          # Rate control: target bitrate, in bps
-KeepHierarchicalBit                 : 1                # Rate control: keep hierarchical bit allocation in rate control algorithm
-LCULevelRateControl                 : 1                # Rate control: 1: LCU level RC; 0: picture level RC
-RCLCUSeparateModel                  : 1                # Rate control: use LCU level separate R-lambda model
-InitialQP                           : 0                # Rate control: initial QP
-RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
 
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
Index: branches/SHM-2.1-dev/cfg/encoder_randomaccess_he10.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/encoder_randomaccess_he10.cfg	(revision 193)
+++ branches/SHM-2.1-dev/cfg/encoder_randomaccess_he10.cfg	(revision 211)
@@ -106,7 +106,19 @@
 
 #============ Rate Control ======================
-RateCtrl                            : 0                # 0: Disable rate control 1: Enable rate control
-TargetBitrate                       : 1000             # input target bitrate when RateCtrl is enable
-NumLCUInUnit                        : 1                # Number of LCU in an Unit. Fraction is not allowed
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
 
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
Index: branches/SHM-2.1-dev/cfg/encoder_randomaccess_main.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/encoder_randomaccess_main.cfg	(revision 193)
+++ branches/SHM-2.1-dev/cfg/encoder_randomaccess_main.cfg	(revision 211)
@@ -106,11 +106,19 @@
 
 #============ Rate Control ======================
-RateControl                         : 0                # Rate control: enable rate control
-TargetBitrate                       : 1000000          # Rate control: target bitrate, in bps
-KeepHierarchicalBit                 : 1                # Rate control: keep hierarchical bit allocation in rate control algorithm
-LCULevelRateControl                 : 1                # Rate control: 1: LCU level RC; 0: picture level RC
-RCLCUSeparateModel                  : 1                # Rate control: use LCU level separate R-lambda model
-InitialQP                           : 0                # Rate control: initial QP
-RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
 
 SEIpictureDigest                    : 1
Index: branches/SHM-2.1-dev/cfg/encoder_randomaccess_main10.cfg
===================================================================
--- branches/SHM-2.1-dev/cfg/encoder_randomaccess_main10.cfg	(revision 193)
+++ branches/SHM-2.1-dev/cfg/encoder_randomaccess_main10.cfg	(revision 211)
@@ -106,11 +106,19 @@
 
 #============ Rate Control ======================
-RateControl                         : 0                # Rate control: enable rate control
-TargetBitrate                       : 1000000          # Rate control: target bitrate, in bps
-KeepHierarchicalBit                 : 1                # Rate control: keep hierarchical bit allocation in rate control algorithm
-LCULevelRateControl                 : 1                # Rate control: 1: LCU level RC; 0: picture level RC
-RCLCUSeparateModel                  : 1                # Rate control: use LCU level separate R-lambda model
-InitialQP                           : 0                # Rate control: initial QP
-RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
+RateControl0                  : 0           # Rate control: enable rate control for layer 0
+TargetBitrate0                : 1000000     # Rate control: target bitrate for layer 0, in bps
+KeepHierarchicalBit0          : 1           # Rate control: keep hierarchical bit allocation for layer 0 in rate control algorithm
+LCULevelRateControl0          : 1           # Rate control: 1: LCU level RC for layer 0; 0: picture level RC for layer 0
+RCLCUSeparateModel0           : 1           # Rate control: use LCU level separate R-lambda model for layer 0
+InitialQP0                    : 0           # Rate control: initial QP for layer 0
+RCForceIntraQP0               : 0           # Rate control: force intra QP to be equal to initial QP for layer 0
+
+RateControl1                  : 0           # Rate control: enable rate control for layer 1
+TargetBitrate1                : 1000000     # Rate control: target bitrate for layer 1, in bps
+KeepHierarchicalBit1          : 1           # Rate control: keep hierarchical bit allocation for layer 1 in rate control algorithm
+LCULevelRateControl1          : 1           # Rate control: 1: LCU level RC for layer 1; 0: picture level RC for layer 1
+RCLCUSeparateModel1           : 1           # Rate control: use LCU level separate R-lambda model for layer 1
+InitialQP1                    : 0           # Rate control: initial QP for layer 1
+RCForceIntraQP1               : 0           # Rate control: force intra QP to be equal to initial QP for layer 1
 
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###