Index: branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 193)
+++ branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_2view+depth.cfg	(revision 213)
@@ -157,5 +157,5 @@
 SignHideFlag                   : 1                                 # sign hiding
 SignHideThreshold              : 4                                 # sign hiding threshold
-
+IlluCompEnable                 : 1                                 # illumination compensation (0: OFF, 1: ON)
 
 #============ PCM ================
@@ -195,4 +195,8 @@
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
+DisparitySearchRangeRestriction : 0                                # 0: No disparity restriction 1: Use disparity restriction
+VerticalDisparitySearchRange    : 56                               # vertical disparity search range (in luma samples)
+FCO                        : 0                                     # Flexible coding order flag in 3DV
+FCOCodingOrder             : T0D0D1T1                              # Coding order for Flexible coding order in 3DV
 
 
@@ -201,5 +205,7 @@
 MVI                       : 1                                      # motion parameter inheritance
 VSO                       : 1                                      # use of view synthesis optimization for depth coding
-
+QTLPC                     : 1                                      # use of quadtree limitation + predictive coding of the quadtree for depth coding
+SDC                       : 1                                      # use simplified depth coding tree
+DLT                       : 1                                      # use depth lookup table
 
 #========== texture coding tools based on depth ==========
@@ -209,11 +215,9 @@
 #========== view synthesis optimization (VSO) ==========
 VSOConfig                 : [cx0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) I(s0.25 s0.5 s0.75)]  # VSO configuration string
-WVSO                      : 0
-VSOWeight                 : 10
-VSDWeight                 : 1
-DWeight                   : 1
-
-#========== Non-normative encoder techniques ==========
-DPL                       : 0
+#VSOConfig                 : [ox0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) I(s0.25 s0.5 s0.75)]  # VSO configuration string
+WVSO                      : 1                                    # use of WVSO (Depth distortion metric with a weighted depth fidelity term) 
+VSOWeight                 : 10                                   # weight of VSO ( in SAD case, cf. squared in SSE case )
+VSDWeight                 : 1                                    # weight of VSD ( in SAD case, cf. squared in SSE case )
+DWeight                   : 1                                    # weight of depth distortion itself ( in SAD case, cf. squared in SSE case )
 
 #============ Misc. ================
Index: branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_2view.cfg
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 193)
+++ branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_2view.cfg	(revision 213)
@@ -151,5 +151,5 @@
 SignHideFlag                   : 1                                 # sign hiding
 SignHideThreshold              : 4                                 # sign hiding threshold
-
+IlluCompEnable                 : 1                                 # illumination compensation (0: OFF, 1: ON)
 
 #============ PCM ================
@@ -189,5 +189,6 @@
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
-
+DisparitySearchRangeRestriction : 0                                # 0: No disparity restriction 1: Use disparity restriction
+VerticalDisparitySearchRange    : 56                               # vertical disparity search range (in luma samples)
 
 #========== depth coding tools ==========
Index: branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 193)
+++ branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_3view+depth.cfg	(revision 213)
@@ -1,3 +1,2 @@
-
 #========== file i/o ==========
 InputFile_0               : org_0.yuv                              # video input file for view 0
@@ -161,5 +160,5 @@
 SignHideFlag                   : 1                                 # sign hiding
 SignHideThreshold              : 4                                 # sign hiding threshold
-
+IlluCompEnable                 : 1                                 # illumination compensation (0: OFF, 1: ON)
 
 #============ PCM ================
@@ -199,4 +198,8 @@
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
+DisparitySearchRangeRestriction : 0                                # 0: No disparity restriction 1: Use disparity restriction
+VerticalDisparitySearchRange    : 56                               # vertical disparity search range (in luma samples)
+FCO                        : 0                                      # Flexible coding order flag in 3DV
+FCOCodingOrder             : T0D0D1D2T1T2                           # Coding order for Flexible coding order in 3DV
 
 
@@ -205,4 +208,7 @@
 MVI                       : 1                                      # motion parameter inheritance
 VSO                       : 1                                      # use of view synthesis optimization for depth coding
+QTLPC                     : 1                                      # use of quadtree limitation + predictive coding of the quadtree for depth coding
+SDC                       : 1                                      # use simplified depth coding tree
+DLT                       : 1                                      # use depth lookup table
 
 #========== texture coding tools based on depth ==========
@@ -212,11 +218,9 @@
 #========== view synthesis optimization (VSO) ==========
 VSOConfig                 : [cx0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][cx2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string
-WVSO                      : 0
-VSOWeight                 : 10
-VSDWeight                 : 1
-DWeight                   : 1
-
-#========== Non-normative encoder techniques ==========
-DPL                       : 0
+#VSOConfig                 : [ox0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][ox2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string for FCO = 1
+WVSO                       : 1                                     # use of WVSO (Depth distortion metric with a weighted depth fidelity term) 
+VSOWeight                  : 10                                    # weight of VSO ( in SAD case, cf. squared in SSE case )
+VSDWeight                  : 1                                     # weight of VSD ( in SAD case, cf. squared in SSE case )
+DWeight                    : 1                                     # weight of depth distortion itself ( in SAD case, cf. squared in SSE case )
 
 #============ Misc. ================
Index: branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_3view.cfg
===================================================================
--- branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 193)
+++ branches/HTM-4.0.1-VSP-dev0/CommonTestConditionsCfgs/baseCfg_3view.cfg	(revision 213)
@@ -153,5 +153,5 @@
 SignHideFlag                   : 1                                 # sign hiding
 SignHideThreshold              : 4                                 # sign hiding threshold
-
+IlluCompEnable                 : 1                                 # illumination compensation (0: OFF, 1: ON)
 
 #============ PCM ================
@@ -191,4 +191,6 @@
 InterViewSkip             : 0                                      # interview SKIP mode
 InterViewSkipLambdaScale  : 8                                      # lambda scale for inter-view skip mode
+DisparitySearchRangeRestriction : 0                                # 0: No disparity restriction 1: Use disparity restriction
+VerticalDisparitySearchRange    : 56                               # vertical disparity search range (in luma samples)
 
 